/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* t-l-ger.p - German language definitions for Labels module */

{ prores/t-define.i }

DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.

IF qbf-s < 0 THEN RETURN.
qbf-lang = "".

/*--------------------------------------------------------------------------*/
/* l-guess.p:1..5,l-verify.p:6.. */
IF qbf-s = 1 THEN
  ASSIGN
    qbf-lang[ 1] = 'Suche in "~{1~}" nach dem Feld "~{2~}" ...'
    qbf-lang[ 2] = 'In den Dateien sind keine Felder mit Standardnamen '
		 + 'vorhanden.'
    qbf-lang[ 4] = 'Aufbau der Felder fr das Label'
    qbf-lang[ 5] = 'Anrede,Name,Anschrift1,Anschrift2,Strae,Postfach,'
		 + 'PLZ,Ort,PLZ+Ort,Land'

    qbf-lang[ 6] = 'Zeile ~{1~}: Klammern fehlen oder sind nicht geschlossen.'
    qbf-lang[ 7] = 'Zeile ~{2~}: Das Feld "~{1~}" kann nicht gefunden werden.'
    qbf-lang[ 8] = 'Zeile ~{2~}: Das Feld "~{1~}" ist kein Listenelementfeld.'
    qbf-lang[ 9] = 'Zeile ~{2~}: Feld  "~{1~}", Listenelement ~{3~}, liegt '
		 + 'auerhalb des Bereichs.'
    qbf-lang[10] = 'Zeile ~{2~}: Das Feld "~{1~}" gehrt zu einer Datei, '
		 + 'die nicht aktiv ist.'.

ELSE

/*--------------------------------------------------------------------------*/
/* l-main.p */
IF qbf-s = 2 THEN
  ASSIGN
    /* each entry of 1 and also 2 must fit in format x(6) */
    qbf-lang[ 1] = 'Datei:,     :,     :,     :,     :'
    qbf-lang[ 2] = 'Order:'
    qbf-lang[ 3] = 'Etikett Info'
    qbf-lang[ 4] = 'Etikett Layout'
    qbf-lang[ 5] = 'Whlen Sie ein Feld'
    /*cannot change length of 6 thru 17, right-justify 6-11,13-14 */
    qbf-lang[ 6] = 'Leerzeilunterdr.:'
    qbf-lang[ 7] = '   Anzahl Kopien:'
    qbf-lang[ 8] = '    Gesamthhe:'
    qbf-lang[ 9] = '   Oberer Rand:'
    qbf-lang[10] = '        Etikettbreite:'
    qbf-lang[11] = '          Linker Rand:'
    qbf-lang[12] = '(breit)'
    qbf-lang[13] = ' Etikett-Text'
    qbf-lang[14] = '   und Felder'
    qbf-lang[15] = 'Etiketten         ' /* 15..17 used as group.   */
    qbf-lang[16] = 'nebenein-         ' /*   do not change length, */
    qbf-lang[17] = 'ander:       ' /*        but do right-justify  */
    qbf-lang[19] = 'Sie haben noch ein Etikett in Bearbeitung. Soll der '
		 + 'Bildschirm gelscht werden?'
    qbf-lang[20] = 'Ihr Etikett besteht aus ~{2~} Zeilen, Sie haben aber '
		 + 'nur ~{1~} definiert. '
		 + 'Einige Informationen sind grer als Ihr Etikett'
		 + 'und knnen deshalb nicht ausgedruckt werden. Wollen Sie'
		 + 'trotzdem weitermachen und die Etiketten ausdrucken lassen?'
    qbf-lang[21] = 'Keine Etikettfelder oder -texte fr die Ausgabe vorhanden!'
    qbf-lang[22] = 'Das Programm fr die Etiketten wird erstellt...'
    qbf-lang[23] = 'Das Programm fr die Etiketten wird kompiliert...'
    qbf-lang[24] = 'Das Programm fr die Etikettausgabe wird ausgefhrt...'
    qbf-lang[25] = 'Keine Schreibrechte fr die Datei bzw. das Gert'
    qbf-lang[26] = '~{1~} Etiketten wurden ausgegeben.'
    qbf-lang[27] = 'L. Layout bearbeiten'
    qbf-lang[28] = 'N. Neue Dateien/Felder'
    qbf-lang[29] = 'Soll RESULTS in den Dateien nach Standardfeldern fr '
		 + 'Etiketten suchen?'
    qbf-lang[31] = 'Sollen der Bildschirm wirklich gelscht werden?'
    qbf-lang[32] = 'Wollen Sie das Modul "Etikett" wirklich verlassen?'.

ELSE

/*--------------------------------------------------------------------------*/
/* l-main.p */
IF qbf-s = 3 THEN
  ASSIGN
    qbf-lang[ 1] = 'Der Textabstand zwischen Etiketten mu > 0 sein.'
    qbf-lang[ 2] = 'Der obere Rand kann nicht negativ sein.'
    qbf-lang[ 3] = 'Die Gesamthhe mu grer als 1 sein.'
    qbf-lang[ 4] = 'Die Anzahl Etiketten nebeneinander mu mindestens 1 sein.'
    qbf-lang[ 5] = 'Die gewnschte Kopienanzahl mu mindestens 1 sein.'
    qbf-lang[ 6] = 'Der linke Rand kann nicht negativ sein.'
    qbf-lang[ 7] = 'Der Textabstand mu grer als 1 sein.'
    qbf-lang[ 8] = 'ja = Leerzeilenunterdrckung. Text rckt 1 Zeile nach oben.'
    qbf-lang[ 9] = 'Zeilenzahl vom oberen Etikettrand bis zur ersten Druckzeile'
    qbf-lang[10] = 'Gesamthhe des Etiketts in Zeilen.'
    qbf-lang[11] = 'Anzahl Etiketten nebeneinander.'
    qbf-lang[12] = 'Anzahl, wie oft jedes Etikett ausgegeben wird.'
    qbf-lang[13] = 'Leerzeichen vom Etikettrand bis zur ersten Druckposition.'
    qbf-lang[14] = 'Abstand linke Ecke eines Etiketts zum nchsten Etikett'.

/*--------------------------------------------------------------------------*/

RETURN.
