/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* t-l-swe.p - Swedish language definitions for Labels module */

{ prores/t-define.i }

DEFINE INPUT PARAMETER qbf-s AS INTEGER NO-UNDO.

IF qbf-s < 0 THEN RETURN.
qbf-lang = "".

/*--------------------------------------------------------------------------*/
/* l-guess.p:1..5,l-verify.p:6.. */
IF qbf-s = 1 THEN
  ASSIGN
    qbf-lang[ 1] = 'Sker i "~{1~}" efter "~{2~}" flt...'
    qbf-lang[ 2] = 'Inga flt kunde hittas med automatisk skning.'
    qbf-lang[ 4] = 'Stter upp etikettflt'
    qbf-lang[ 5] = 'namn,adr1,adr2,adr3,'
                 + 'pnr-stad,pnr,stad,land,ex-1,ex-2'

    qbf-lang[ 6] = 'Rad ~{1~}: Klamrar ej parvis.'
    qbf-lang[ 7] = 'Rad ~{2~}: Hittar ej flt "~{1~}".'
    qbf-lang[ 8] = 'Rad ~{2~}: Flt "~{1~}", r inget matrisflt.'
    qbf-lang[ 9] = 'Rad ~{2~}: Flt "~{1~}", element ~{3~} utanfr intervall.'
    qbf-lang[10] = 'Rad ~{2~}: Flt "~{1~}", frn ej vald fil.'.

ELSE

/*--------------------------------------------------------------------------*/
/* l-main.p */
IF qbf-s = 2 THEN
  ASSIGN
    /* each entry of 1 and also 2 must fit in format x(6) */
    qbf-lang[ 1] = 'Filer:,     :,     :,     :,     :'
    qbf-lang[ 2] = 'Ordn.:'
    qbf-lang[ 3] = 'Etikettinfo'
    qbf-lang[ 4] = 'Etikettlayout'
    qbf-lang[ 5] = 'Vlj ett flt'
    /*cannot change length of 6 thru 17, right-justify 6-11,13-14 */
    qbf-lang[ 6] = ' Skippa tomrader:'
    qbf-lang[ 7] = ' Kopior av varje:'
    qbf-lang[ 8] = '    Total hjd:'
    qbf-lang[ 9] = '  Toppmarginal:'
    qbf-lang[10] = ' Text t. text avstnd:'
    qbf-lang[11] = '     Vnster marginal:'
    qbf-lang[12] = '(bredd)'
    qbf-lang[13] = '   Etikettext'
    qbf-lang[14] = '     och flt'
    qbf-lang[15] = 'Antal             ' /* 15..17 used as group.   */
    qbf-lang[16] = 'etiketter         ' /*   do not change length, */
    qbf-lang[17] = 'i sidled:      ' /*        but do right-justify  */
    qbf-lang[19] = 'Du rensade inte bort aktuell etikett. '
                 + 'Vill du nd fortstta?'
    qbf-lang[20] = 'Etiketthjd r ~{1~}, men du har ~{2~} rader '
                 + 'definierade. En del av informationen fr ej plats p  '
                 + 'etiketten och kommer drfr ej att skrivas.  '
                 + 'Vill du nd fortstta med utskrift av etiketterna?'
    qbf-lang[21] = 'Etikettext eller flt saknas fr utskrift!'
    qbf-lang[22] = 'Genererar etikettprogram...'
    qbf-lang[23] = 'Kompilerar etikettprogram..'
    qbf-lang[24] = 'Kr genererat program...'
    qbf-lang[25] = 'Kunde ej skriva till fil el enhet.'
    qbf-lang[26] = '~{1~} etiketter utskrivna.'
    qbf-lang[27] = 'F. Flt'
    qbf-lang[28] = 'A. Aktiva tabeller'
    qbf-lang[29] = 'Skall programmet frska vlja flt till etiketterna '
                 + 'automatiskt?'
    qbf-lang[31] = 'Skert att du vill ta bort dessa instllningar?'
    qbf-lang[32] = 'Skert att du vill avsluta denna modul?'.

ELSE

/*--------------------------------------------------------------------------*/
/* l-main.p */
IF qbf-s = 3 THEN
  ASSIGN
    qbf-lang[ 1] = 'Om mer n 1 etikett i sidled mste textavstnd vara > 0'
    qbf-lang[ 2] = 'Toppmarginal kan ej vara < 0'
    qbf-lang[ 3] = 'Total hjd mste vara > 1'
    qbf-lang[ 4] = 'Antal etiketter i sidled mste vara > 0'
    qbf-lang[ 5] = 'Antal kopior mste vara > 0'
    qbf-lang[ 6] = 'Vnstermarginal kan ej vara < 0'
    qbf-lang[ 7] = 'Textmellanrum mste vara > 1'
    qbf-lang[ 8] = 'Flytta upp lgre rader vid tom rad'
    qbf-lang[ 9] = 'Antal tomma rader fre frsta skrivraden p etiketten'
    qbf-lang[10] = 'Total etiketthjd i antal rader'
    qbf-lang[11] = 'Antal etiketter i sidled'
    qbf-lang[12] = 'Antal kopior av varje etikett'
    qbf-lang[13] = 'Antal blanka frn vnsterkant till frsta skrivposition'
    qbf-lang[14] = 'Avstnd frn vnsterkant av en etikett t. vkant av nsta'.

/*--------------------------------------------------------------------------*/

RETURN.
